﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Barcode;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Windows.PdfViewer;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace App2
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }       
        private async void button_Click(object sender, RoutedEventArgs e)
        {
            //Set the barcode size
            SizeF barcodeSize = new SizeF(300, 300);

            //Create a new PDF document
            PdfDocument doc = new PdfDocument();

            //Set PDF page size
            doc.PageSettings.Size = barcodeSize;

            //Set page margins
            doc.PageSettings.Margins.All = 0;

            //Add a new PDF page
            PdfPage page = doc.Pages.Add();

            //Create a PDF barcode
            PdfQRBarcode qr = new PdfQRBarcode();

            //Set barcode size
            qr.Size = barcodeSize;

            //Set the barcode text
            qr.Text = "www.syncfusion.com";

            //qr.XDimension = 8;

            //Draw the barcode to PDF page
            qr.Draw(page, PointF.Empty);

            MemoryStream ms = new MemoryStream();

            //Save the PDF document 
            await doc.SaveAsync(ms);

            //Close the document
            doc.Close(true);

            ms.Position = 0;
       
            //Load the PDF document to the PDF viewer control
            await control.LoadDocumentAsync(ms);

            //Get the page as image
            //Image img = control.GetPage(0);

            //Export the page as image stream
            Stream img = await control.ExportAsImage(0);

            Save(img);
        }      

        async void Save(Stream stream)
        {
            stream.Position = 0;

            FileSavePicker savePicker = new FileSavePicker();
            savePicker.DefaultFileExtension = ".png";
            savePicker.SuggestedFileName = "Final";
            savePicker.FileTypeChoices.Add("PNG", new List<string>() { ".png" });
            StorageFile stFile = await savePicker.PickSaveFileAsync();
            if (stFile != null)
            {
                Windows.Storage.Streams.IRandomAccessStream fileStream = await stFile.OpenAsync(FileAccessMode.ReadWrite);
                Stream st = fileStream.AsStreamForWrite();
                st.SetLength(0);

                await stream.CopyToAsync(st);
                await st.FlushAsync();

                st.Dispose();
                fileStream.Dispose();

                MessageDialog msgDialog = new MessageDialog("Do you want to view the Document?", "File has been created successfully.");
                UICommand yesCmd = new UICommand("Yes");
                msgDialog.Commands.Add(yesCmd);
                UICommand noCmd = new UICommand("No");
                msgDialog.Commands.Add(noCmd);
                IUICommand cmd = await msgDialog.ShowAsync();
                if (cmd == yesCmd)
                {
                    // Launch the retrieved file
                    bool success = await Windows.System.Launcher.LaunchFileAsync(stFile);
                }
            }

            else if (stFile == null)
            {
                //disposing saved stream
                await stream.FlushAsync();
                stream.Dispose();
            }
        }

    }
}
